using System;
using System.Drawing;

using MonoTouch.Foundation;
using MonoTouch.UIKit;

namespace Torch
{
	public partial class TorchViewController : UIViewController
	{
		public TorchViewController () : base ("TorchViewController", null)
		{
		}
		
		public override void DidReceiveMemoryWarning ()
		{
			// Releases the view if it doesn't have a superview.
			base.DidReceiveMemoryWarning ();
			
			// Release any cached data, images, etc that aren't in use.
		}
		
		private BulbViewController bulbController;
		
		private void InfoAlert (string title, string message, EventHandler<UIButtonEventArgs> callback)
		{
			UIAlertView av = new UIAlertView (title, message, null, "OK");
			av.Dismissed += callback;
			av.Show ();
		}
		
		private void ConfirmAlert (string title, string message, EventHandler<UIButtonEventArgs> callback)
		{
			UIAlertView av = new UIAlertView (title, message, null, "No", "Yes");
			av.Clicked += callback;
			av.Show ();
		}
		
		private void TorchLaunch (object sender, UIButtonEventArgs e)
		{
			if (bulbController == null)
				bulbController = new BulbViewController ();
			View.AddSubview (bulbController.View);
		}
		
		private void TorchLaunchConfirm (object sender, UIButtonEventArgs e)
		{
			if (e.ButtonIndex == 1)
				InfoAlert ("Information", "Torch is being turned on...", TorchLaunch);
		}
		
		public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();
			
			// Perform any additional setup after loading the view, typically from a nib.
			torchButton.TouchUpInside += delegate {
				ConfirmAlert ("Confirmation", "Are you sure you want\nto turn on the torch?", TorchLaunchConfirm);				
			};
		}
		
		public override void ViewDidUnload ()
		{
			base.ViewDidUnload ();
			
			// Clear any references to subviews of the main view in order to
			// allow the Garbage Collector to collect them sooner.
			//
			// e.g. myOutlet.Dispose (); myOutlet = null;
			
			ReleaseDesignerOutlets ();
		}
		
		public override bool ShouldAutorotateToInterfaceOrientation (UIInterfaceOrientation toInterfaceOrientation)
		{
			// Return true for supported orientations
			return (toInterfaceOrientation != UIInterfaceOrientation.PortraitUpsideDown);
		}
	}
}

